unit DBF_IDX;
{$N+,E+}
interface
uses Dos,Objects;

{-------------------------------------------------------------------------}
type
    TNdxHead = Record
                 Root        : Longint; { ⥫  ୥ }
                                        { 設 }
                 Next_Blk    : Longint;
                 Unknwn1     : Longint;
                 Key_Lgth    : Integer; {   }
                 Max_Keys    : Integer;
                 Data_Typ    : Integer;
                 Entry_Sz    : Integer;
                 Unknwn2     : Longint;
                 Key_Form    : array [0..487] of Char;
               end;

    TNdxData = Record
                 Entry_Ct    : Integer;
                 Unknwn1     : Integer;
                 Data_Ary    : array [0..507] of Byte;
               end;

    TNdxEntPtr = ^TNdxEtry;

    TNdxEtry = Record
                 Block_Ax : Longint;
                 Recrd_Ax : Longint;
                 case Integer of
                  0    : (Char_Fld : array [1..255] of Char);
                  1    : (Numb_Fld : Double);
                 end;

    TNdxTabl = Record
                 Page_No  : Longint;
                 Etry_No  : Integer;
                 Last_One : Integer;
                 Node_Pag : Boolean;
               end;

    PBaseIX = ^TBaseIX;
    TBaseIX = object(TObject)
                 Ndx_Name     : String[64];
                 Ndx_Hdr      : TNdxHead;
                 Ndx_File     : file;
                 Ndx_Tabl     : array [1..25] of  TNdxTabl;
                 Ndx_Lvl      : Integer;
                 Ndx_Data     : TNdxData;
                 Ndx_Pntr     : TNdxEntPtr;
                 constructor Init(IName : String);
                 destructor  Done; virtual;
                 function  KeyEOF : Boolean;
                 function  KeyRead(A : Longint) : Longint;
                 function  KeyFind(St : String) : Longint;
              end;

implementation
{-------------------------------------------------------------------------}
const
   Next_Record = -1;
   Prev_Record = -2;
   Top_Record  = -3;
   Bttm_Record = -4;

{.........................................................................}
constructor  TBaseIX.Init(IName : String);
var
   Ct   : Word;
   SRec : SearchRec;
begin
   inherited Init;
   Ndx_Name := IName + '.NDX';
   System.Assign(Ndx_File,Ndx_Name);
   FindFirst(Ndx_Name,AnyFile, SRec);
   if DosError <> 0 then  { ᫨  䠩 ... }
    begin
      System.Rewrite(Ndx_File,1);
      {===      ᭮ 䠩 ===}
      FillChar(Ndx_Hdr,SizeOf(Ndx_Hdr),0);

      {=========================================================}
      BlockWrite(Ndx_File,Ndx_Hdr,512,Ct);
    end
     else
    begin
      System.Reset(Ndx_File,1);
      BlockRead(Ndx_File,Ndx_Hdr,512,Ct);
    end;
   Ndx_Lvl := 0;
end;

{.........................................................................}
destructor  TBaseIX.Done;
begin
   System.Close(Ndx_File);
   inherited Done;
end;

{.........................................................................}
function  TBaseIX.KeyEOF : Boolean;
var
   EFlg : Boolean;
   I    : Integer;
begin
   EFlg := True;
   if Ndx_Lvl = 0 then EFlg := False
   else
      for I := 1 to Ndx_Lvl do
         if Ndx_Tabl[I].Etry_No < Ndx_Tabl[I].Last_One then EFlg := False;
   KeyEOF := EFlg;
end;

{.........................................................................}
function   TBaseIX.KeyRead(A : Longint) : Longint;
var
   RNum       : Longint;
   Result     : Integer;
   RPag       : Longint;
   N_L_Hold   : Integer;
   Ct         : Integer;

   function Last_Entry(Ix : Longint) : Boolean;
   begin
      if Ndx_Tabl[Ix].Etry_No = Ndx_Tabl[Ix].Last_One then
         Last_Entry := true else Last_entry := False;
   end;


   procedure Get_Next_RecPage;
   begin
      while RPag <> 0 do
      begin
         Seek(Ndx_File,RPag*512);
         BlockRead(Ndx_File,Ndx_Data,512,ct);
         inc(Ndx_Lvl);
         Ndx_Tabl[Ndx_Lvl].Page_No := RPag;
         Ndx_Tabl[Ndx_Lvl].Etry_No := 1;
         Ndx_Tabl[Ndx_Lvl].Last_One := Ndx_Data.Entry_Ct+1;
         Ndx_Tabl[Ndx_Lvl].Node_Pag := true;
         Ndx_Pntr :=  Addr(Ndx_Data.Data_Ary);
         RPag := Ndx_Pntr^.Block_Ax;
      end;
      Ndx_Tabl[Ndx_Lvl].Node_Pag := False;
      dec(Ndx_Tabl[Ndx_Lvl].Last_One);
      RNum := Ndx_Pntr^.Recrd_Ax;
   end;

   procedure Get_Prev_RecPage;
   begin
      while RPag <> 0 do
      begin
         Seek(Ndx_File,RPag*512);
         BlockRead(Ndx_File,Ndx_Data,512,ct);
         Inc(Ndx_Lvl);
         Ndx_Tabl[Ndx_Lvl].Page_No := RPag;
         Ndx_Tabl[Ndx_Lvl].Etry_No := Ndx_Data.Entry_Ct+1;
         Ndx_Tabl[Ndx_Lvl].Last_One := Ndx_Data.Entry_Ct+1;
         Ndx_Tabl[Ndx_Lvl].Node_Pag := True;
         Ndx_Pntr :=
                      Addr(Ndx_Data.Data_Ary[(
                      (Ndx_Data.Entry_Ct)*Ndx_Hdr.Entry_Sz)]);
         RPag := Ndx_Pntr^.Block_Ax;
      end;
      Ndx_Pntr :=
                   Addr(Ndx_Data.Data_Ary[(
                   (Ndx_Data.Entry_Ct-1)*Ndx_Hdr.Entry_Sz)]);
      Ndx_Tabl[Ndx_Lvl].Etry_No := Ndx_Data.Entry_Ct;
      Ndx_Tabl[Ndx_Lvl].Node_Pag := False;
      Dec(Ndx_Tabl[Ndx_Lvl].Last_One);
      RNum := Ndx_Pntr^.Recrd_Ax;
   end;

{ Start of KeyRead }

begin
   RNum := A;
   if ((A = Next_Record) or (A = Prev_Record)) and
      (Ndx_Lvl = 0) then RNum := Top_Record;
   case RNum of
      Next_Record : begin
                       N_L_Hold := Ndx_Lvl;
                       if Last_Entry(Ndx_Lvl) then
                       begin
                          while (Last_Entry(Ndx_Lvl)) and (Ndx_Lvl > 0) do
                             Dec(Ndx_Lvl);
                          if Ndx_Lvl = 0 then
                          begin
                             Ndx_Lvl := N_L_Hold;
                          end else
                          begin
                             RPag := Ndx_Tabl[Ndx_Lvl].Page_No;
                             Seek(Ndx_File,RPag*512);
                             Inc(Ndx_Tabl[Ndx_Lvl].Etry_No);
                             BlockRead(Ndx_File,Ndx_Data,512,ct);
                             Ndx_Pntr :=
                                      Addr(Ndx_Data.Data_Ary[(
                                      (Ndx_Tabl[Ndx_Lvl].Etry_No - 1) *
                                      Ndx_Hdr.Entry_Sz)]);
                             RPag := Ndx_Pntr^.Block_Ax;
                             Get_Next_RecPage;
                          end;
                          dec(Ndx_Tabl[Ndx_Lvl].Etry_No);
                       end;
                       Inc(Ndx_Tabl[Ndx_Lvl].Etry_No);
                       Ndx_Pntr :=
                                    Addr(Ndx_Data.Data_Ary[(
                                    (Ndx_Tabl[Ndx_Lvl].Etry_No - 1) *
                                    Ndx_Hdr.Entry_Sz)]);
                       RNum := Ndx_Pntr^.Recrd_Ax;
                    end;
      Prev_Record : begin
                       N_L_Hold := Ndx_Lvl;
                       if Ndx_Tabl[Ndx_Lvl].Etry_No = 1 then
                       begin
                          while (Ndx_Tabl[Ndx_Lvl].Etry_No = 1) and
                                (Ndx_Lvl > 0) do
                             dec(Ndx_Lvl);
                          if Ndx_Lvl = 0 then
                          begin
                             Ndx_Lvl := N_L_Hold ;
                          end else
                          begin
                             RPag := Ndx_Tabl[Ndx_Lvl].Page_No;
                             Seek(Ndx_File,RPag*512);
                             dec(Ndx_Tabl[Ndx_Lvl].Etry_No);
                             BlockRead(Ndx_File,Ndx_Data,512,ct);
                             Ndx_Pntr :=
                                      Addr(Ndx_Data.Data_Ary[(
                                      (Ndx_Tabl[Ndx_Lvl].Etry_No - 1) *
                                      Ndx_Hdr.Entry_Sz)]);
                             RPag := Ndx_Pntr^.Block_Ax;
                             Get_Prev_RecPage;
                          end;
                          Inc(Ndx_Tabl[Ndx_Lvl].Etry_No);
                       end;
                       dec(Ndx_Tabl[Ndx_Lvl].Etry_No);
                       Ndx_Pntr :=
                                    Addr(Ndx_Data.Data_Ary[(
                                    (Ndx_Tabl[Ndx_Lvl].Etry_No - 1) *
                                    Ndx_Hdr.Entry_Sz)]);
                       RNum := Ndx_Pntr^.Recrd_Ax;
                    end;
      Top_Record  : begin
                       Ndx_Lvl := 0;
                       RPag := Ndx_Hdr.Root;
                       Get_Next_RecPage;
                    end;
      Bttm_Record : begin
                       Ndx_Lvl := 0;
                       RPag := Ndx_Hdr.Root;
                       Get_Prev_RecPage;
                    end;
   end;
   KeyRead := RNum;
end;

{.........................................................................}
function  TBaseIX.KeyFind(st : string) : Longint;
var
   long_st   : string[255];
   key_st    : string[255];
   m_num     : Double;
   st_Lth    : Integer;
   RPag      : Longint;
   i         : Integer;
   rl        : Integer;
   ct        : Integer;
   Less_Than : Boolean;
begin
   FillChar(long_st[1], 255, ' ');
   long_st := st;
   st_Lth := Ndx_Hdr.Key_Lgth;
   long_st[0] := chr(st_Lth);
   if Ndx_Hdr.Data_Typ <> 0 then val(st,m_num,rl);
   Ndx_Lvl := 0;
   RPag := Ndx_Hdr.Root;
   while RPag <> 0 do
   begin
      Seek(Ndx_File,RPag*512);
      BlockRead(Ndx_File,Ndx_Data,512,ct);
      Inc(Ndx_Lvl);
      with Ndx_Tabl[Ndx_Lvl] do
      begin
         Page_No := RPag;
         Etry_No := 0;
         Last_One := Ndx_Data.Entry_Ct+1;
         Node_Pag := true;
         i := 1;
         Less_Than := true;
         while (less_than) and (i <= Last_One) do
         begin
            Etry_No := i;
            Ndx_Pntr :=  Addr(Ndx_Data.Data_Ary[((i-1) *  Ndx_Hdr.Entry_Sz)]);
            if Ndx_Hdr.Data_Typ = 0 then
            begin
               move(Ndx_Pntr^.Char_Fld,key_st[1],st_Lth);
               key_st[0] := chr(st_Lth);
               if key_st >= long_st then Less_Than := False;
            end else
            begin
               if Ndx_Pntr^.Numb_Fld >= m_num then Less_Than := False;
            end;
            Inc(I);
         end;
         RPag := Ndx_Pntr^.Block_Ax;
      end;
   end;
   Ndx_Tabl[Ndx_Lvl].Node_Pag := False;
   dec(Ndx_Tabl[Ndx_Lvl].Last_One);
   if Ndx_Hdr.Data_Typ = 0 then
   begin
      if (key_st <> long_st) or
         (Ndx_Tabl[Ndx_Lvl].Last_One < Ndx_Tabl[Ndx_Lvl].Etry_No)
            then KeyFind := 0
         else
            KeyFind := Ndx_Pntr^.Recrd_Ax;
   end else
   begin
      if (Ndx_Pntr^.Numb_Fld <> m_num) or
         (Ndx_Tabl[Ndx_Lvl].Last_One < Ndx_Tabl[Ndx_Lvl].Etry_No)
            then KeyFind := 0
         else
            KeyFind := Ndx_Pntr^.Recrd_Ax;
   end;
end;
{-------------------------------------------------------------------------}
end.

